#ifndef CONSTANTS_H
#define CONSTANTS_H

#define FALSE 0
#define TRUE  1
#define ERROR -2
#define PNULL -1    /* null pointer */
#define EOS   '\0'  /* end of string */
#define EOP   0     /* end of page */

#define MAX_WORD_SIZE 100  /* Maximum size of any key */

#define ROOT            1    /* The root is always stored as first page on disk */
#define FIRST_LEAF_PAGE 2    /* The page number of first (orginal) leaf page */
#define LEAF_SYMBOL     'L'  /* To differentiate a Leaf page */
#define NON_LEAF_SYMBOL 'N'  /* To differentiate a Nonleaf page */
#define NULL_PAGE_NUM   -3   /* null page pointer */
#define NON_EXISTENT    -2

#define DB_DIR         "db"
#define POSTINGS_FILE  DB_DIR "/postings.bin"
#define BTREE_FILE     DB_DIR "/btree.bin"
#define DOCS_FILE      DB_DIR "/docs.bin"
#define PARAMS_FILE    "conf/params"

/* to enable debugging statements */
#define DEBUG
#undef DEBUG  /* disabled */

#endif
