/*
 * Global variables shared across api and btree implementations.
 */

#ifndef GLOBALS_H
#define GLOBALS_H

#include <stdio.h>

/* Database file pointers.  Initialized in db.c */
extern FILE* fp_btree;     /* B-tree file pointer */
extern FILE* fp_postings;  /* Postings file pointer */
extern FILE* fp_docs;      /* Documents file pointer */

/* Database parameters.  Initialized in db.c */
extern int    PAGE_SIZE;       /* Size of page (in bytes) to be stored on disk */
extern int    MAX_DOCS_PTRS;   /* Postings file stores this many ptrs before overflowing */
extern double GROWTH_FACTOR;   /* Postings lists growth factor */
extern long   LIST_SIZE[100];  /* Postings lists sizes */

#endif
