#ifndef DOCS_H
#define DOCS_H

#include <stdio.h>
#include "../common/common.h"
#include "../btree/btree.h"

#define TAG       '\026'  /* ctrl-V - marks start of each doc entry */
#define DOC_START 026     /* (int) TAG */

/*
 * Insert the document (file) 'fname' into the database, PREFIXING it with a TAG (ctrl-V)
 */
void insert_doc(char* fname);

/*
 * Extract the next word from the given document (file) fp,  and put it into the string 'word'.
 * This function leaves the file pointing to the next character after the word that was read.
 *
 * Returns
 *   EOF        If there are no alnum's from the specified position up to the EOF.
 *   ERROR      In case of trouble.
 *   TRUE       In normal cases.
 *   DOC_START  When the TAG character is encountered (when scanning
 *              a collection of docs)
 */
int get_word(FILE* fp, char* word);

/*
 * Print an entry from the docs file 'fp' starting at 'start' with the TAG character.
 */
void print_doc(long offset);

#endif