#include "docs.h"
#include "../utils/hash_table.h"
#include "../utils/common_words.h"

/*
 * Insert the document (file) 'fname' into the database, PREFIXING it with a TAG (ctrl-V)
 */
void insert_doc(char* fname) {
    FILE* fp_input;
    
    if ((fp_input = fopen(fname, "r")) == NULL) {
        printf("Error: Cannot Open Input Word File: %s\n", fname);
        return;
    }

    /* Concatenate the new text file to the file DOCS_FILE
    and place file pointer at the start of the new text file */
    goto_eof(fp_docs);
    long new_doc_offset = ftell(fp_docs);  /* offset to newly concatenated document */
    putc(TAG, fp_docs);  /* prefix with the document separator */
    char c;
    while ((c = getc(fp_input)) != EOF) {
        putc(c, fp_docs);
    }

    fseek(fp_docs, new_doc_offset, 0);

    /* eliminate dupl. words by hashing into a h.table */
    /* also, randomizes them somehow */
    rewind(fp_input);
    hash_table_init();  /* initialize the hash table */
    char word[MAX_WORD_SIZE];
    while (get_word(fp_input, word) != EOF) {
        if (!is_common(word)) {
            str_to_lower(word);  /* turn to lower case only */
            hash_table_insert(word);
        }
    }
#ifdef DEBUG
    hash_table_print();  /* just for testing */
#endif

    while (hash_table_get_next(word) != EOH)
        insert_in_tree(word, new_doc_offset);

    hash_table_free();  /* empties the hash table */

    fclose(fp_input);
}
